using System;
using Google.Apis.Plus.v1.Data;
using System.Diagnostics;

namespace positive 
{
	[System.ComponentModel.ToolboxItem(true)]
	public partial class GooglePlusPost : Gtk.Bin
	{
		private Activity _activity;
		private string _fullImageUrl;

		public GooglePlusPost (Activity activity)
		{
			this.Build ();
			_activity = activity;

			labelArticle.Text =string.Empty;
			labelTitle.Markup = "<b>"+_activity.Title+"</b>";
			imagePerson.Pixbuf = Helper.GetImage (_activity.Actor.Image.Url);
			DateTime dt = DateTime.Parse (_activity.Published);
			labelPublished.Markup = "<small><i>"+dt.ToLongDateString()+" "+dt.ToLongTimeString()+"</i></small>";

			if(_activity.Object.Attachments!=null)
			{
				if(_activity.Object.Attachments.Count>0)
				foreach (var item in _activity.Object.Attachments) {
					if(item.ObjectType == "photo")
					{
						_fullImageUrl = item.FullImage.Url; 
						var image = Helper.GetImage (item.Image.Url);
						if(image!=null)
						{
							//Cut image
							imageArticle.Pixbuf = image;
						}
					}
					if(item.ObjectType == "article")
					{
						labelArticle.Markup = item.Content;
					}
				}
			}
		}

		protected void OnEventboxImageButtonReleaseEvent (object o, Gtk.ButtonReleaseEventArgs args)
		{
			if(!string.IsNullOrEmpty (_fullImageUrl))
			{
				var image = Helper.DownloadImage (_fullImageUrl);
				if(image != null)
				{
					image.Save ("tmp.png","png");
					Process.Start ("tmp.png");
				}
				else
				{
					Gtk.MessageDialog md = new Gtk.MessageDialog(null, Gtk.DialogFlags.Modal, Gtk.MessageType.Error, Gtk.ButtonsType.Ok,false,"Error");
					md.Text = "Could not download image";
					md.Run ();
					md.Destroy ();
				}
			}
		}

		protected void OnEventboxPersonButtonReleaseEvent (object o, Gtk.ButtonReleaseEventArgs args)
		{
			Process.Start (_activity.Actor.Url);
		}


		protected void OnButtonBrowserReleased (object sender, EventArgs e)
		{
			Process.Start (_activity.Url);
		}
	}
}

