using System;
using Gtk;
using positive;
using Google.Apis.Plus.v1.Data;

public partial class MainWindow: Gtk.Window
{	
	private positive.SearchPerson _searchWindow = new positive.SearchPerson();
	
	public MainWindow (): base (Gtk.WindowType.Toplevel)
	{
		Build ();
		_searchWindow.Modal=true;
		Helper.OpenFollowingPersons ();
		Helper.InitCache ();
		Cache.LoadCache ();

		var Activities = Helper.GetActivities ();

		foreach (var item in Activities) {
			AddActivity (item);
		}
	}

	private void AddActivity (Activity activity)
	{
		var post = new positive.GooglePlusPost(activity);
		vboxActivities.PackEnd (post,true,true,3);
		var hs = new HSeparator();
		vboxActivities.PackEnd (hs,false,true,5);
		hs.Show ();
		post.Show ();
	}

	protected void OnDeleteEvent (object sender, DeleteEventArgs a)
	{
		Application.Quit ();
		a.RetVal = true;
		Cache.SaveCache ();
	}
	protected void OnFindPersonActionActivated (object sender, EventArgs e)
	{
		_searchWindow.Show ();
	}
	protected void OnRefreshActionActivated (object sender, EventArgs e)
	{
		var Activities = Helper.GetActivities ();
		for (int i = vboxActivities.Children.Length-1; i >0; i--) {
			vboxActivities.Remove (vboxActivities.Children[i]);
		}
		foreach (var item in Activities) {
			AddActivity (item);
		}
	}

	protected void OnFindAndReplaceActionActivated (object sender, System.EventArgs e)
	{
		_searchWindow.Show ();
	}
}
